#include <stdio.h>
#include <termios.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>




int main(int argc, char	*argv[])
{

	int	fd,ret;
	char	buf[1024];
	struct termios T_new;
	
	char port[30];
	
	int port_idx = atoi(argv[1]);
	
	
	//sprintf(port,"/dev/ttyO1");//RS-485 1
	//sprintf(port,"/dev/ttyO2");//RS-485 2
	//sprintf(port,"/dev/ttyO3");//Uart B TX only
	//sprintf(port,"/dev/ttyO4");//Uart A
	//sprintf(port,"/dev/ttyO5");//RS-232
	
	if(argc == 2 && port_idx >= 1 && port_idx <= 5)
	{
            sprintf(port,"/dev/ttyO%d",port_idx);
    }
    else
    {
        printf("Error port 1~5\n");
        return ;
    }



    

    //}ҦC 
     fd = open(port, O_RDWR | O_NOCTTY | O_NDELAY);
    
	    if (fd == -1) 
        {
		 printf("open %s Failed, errno: %d\n",port, errno);
		 return 0;
	    }
	//oثeC𪺳]w 
        if (tcgetattr(fd, &T_new) != 0) 
        {
		 printf("tcgetattr failed. errno: %d\r\n", errno);
		 close(fd);
		 return 0; 
        }
        
    //]wCUѼ  
	    //c_cflag]wiѦhttp://hilinux.com/man/linuxdev/ch09s05.html (|ܱҥ &~ ܤҥ) 
        T_new.c_cflag = (B115200 | CS8 | CREAD | CLOCAL  ); 
        T_new.c_oflag = 0;
        T_new.c_iflag = 0;
        T_new.c_lflag = 0;
        
    //ϳ]wͮ 
        if (tcsetattr(fd, TCSANOW, &T_new) != 0) 
        {
         printf("tcsetattr failed. errno: %d\r\n", errno);
		 close(fd);
		 return 0; 
        }
        
        while(1)
        {
                
          ret = read(fd,buf,1000);
          usleep(20000);
          if(ret > 0)
          {
           buf[ret] = 0x00;
           printf("recv : %s\n",buf);
           write(fd,buf,ret);
           
          }
               
         usleep(20000);
        }


	return 0;
}
